AddWatchMode (Apache ZooKeeper - Server 3.7.0 API)
Date: 2021-03-17

org.apache.zookeeper

## Enum AddWatchMode

- java.lang.Object
- - java.lang.Enum<AddWatchMode>
  - - org.apache.zookeeper.AddWatchMode

- All Implemented Interfaces:
    Serializable, Comparable<AddWatchMode>

      public enum AddWatchMode
      extends Enum<AddWatchMode>

  Modes available to `ZooKeeper.addWatch(String, Watcher, AddWatchMode)`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `PERSISTENT` Set a watcher on the given path that does not get removed when triggered (i.e.
    `PERSISTENT_RECURSIVE` Set a watcher on the given path that: a) does not get removed when triggered (i.e.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getMode()`
    `static AddWatchMode` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static AddWatchMode[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### PERSISTENT

          public static final AddWatchMode PERSISTENT

      Set a watcher on the given path that does not get removed when triggered (i.e. it stays active until it is removed). This watcher is triggered for both data and child events. To remove the watcher, use `removeWatches()` with `WatcherType.Any`. The watcher behaves as if you placed an exists() watch and a getData() watch on the ZNode at the given path.

    - #### PERSISTENT_RECURSIVE

          public static final AddWatchMode PERSISTENT_RECURSIVE

      Set a watcher on the given path that: a) does not get removed when triggered (i.e. it stays active until it is removed); b) applies not only to the registered path but all child paths recursively. This watcher is triggered for both data and child events. To remove the watcher, use `removeWatches()` with `WatcherType.Any`

      The watcher behaves as if you placed an exists() watch and a getData() watch on the ZNode at the given path and any ZNodes that are children of the given path including children added later.

      NOTE: when there are active recursive watches there is a small performance decrease as all segments of ZNode paths must be checked for watch triggering.

  - ### Method Detail

    - #### values

          public static AddWatchMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AddWatchMode c : AddWatchMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AddWatchMode valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getMode

          public int getMode()

Copyright © 2008–2021 The Apache Software Foundation. All rights reserved.